#include <stdio.h>

int setsockopt(int fd, int level, int optname,void *optval, int optlen)
{
   	int retval;
        mm_segment_t oldfs;	
	oldfs = get_fs(); set_fs(KERNEL_DS);   
   	retval = sys_setsockopt(fd, level, optname, optval, optlen);
        set_fs(oldfs);
   	return retval;
}
int getsockopt(int fd, int level, int optname, void *__restrict optval, int *__restrict optlen)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_getsockopt(fd,level,optname, optval,  optlen);
	set_fs(oldfs);
	return retval;
}
 __kernel_sighandler_t signal (int sig, __kernel_sighandler_t __handler)
{
 	__kernel_sighandler_t retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_signal (sig,__handler);
	set_fs(oldfs);
	return retval;
}
int socket(int domain, int type, int protocol)
{
	int retval; 
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_socket(domain, type, protocol);
	set_fs(oldfs);
	return retval;
}
int sigaction (int sig, const struct sigaction * act,struct sigaction *oact)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_sigaction (sig, act,oact);
	set_fs(oldfs);
	return retval;
}
int getitimer (int which,struct itimerval *value)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_getitimer (which,value);
	set_fs(oldfs);
	return retval;
}
int setitimer (int which,const struct itimerval *new,struct itimerval *old)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_setitimer (which,new,old);
	set_fs(oldfs);
	return retval;
}
int gettimeofday (struct timeval *tv,void *tz)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_gettimeofday (tv,tz);
	set_fs(oldfs);
	return retval;
}
int bind(int sockfd, struct sockaddr *my_addr, int addrlen)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_bind(sockfd, my_addr, addrlen);
	set_fs(oldfs);
	return retval;
}
int connect(int sockfd, struct sockaddr *serv_addr, int addrlen)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_connect(sockfd, serv_addr, addrlen);
	set_fs(oldfs);
	return retval;
}
int listen(int sockfd, int backlog)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_listen(sockfd, backlog);
	set_fs(oldfs);
	return retval;
}
int accept(int sockfd, struct sockaddr *addr, int *addrlen)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_accept(sockfd, addr, addrlen);
	set_fs(oldfs);
	return retval;
}
int shutdown(int sockfd, int how)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_shutdown(sockfd, how);
	set_fs(oldfs);
	return retval;
}
/*int fcntl (int fd, int cmd, ...)
{
	int retval;
	retval = sys_fcntl (fd, cmd, ...);
	return retval;
}*/
int getsockname (int fd, struct sockaddr *addr, int *len)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_getsockname (fd, addr, len);
	set_fs(oldfs);
	return retval;
}
int poll (struct pollfd *fds, int nfds, int timeout)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_poll (fds, nfds, timeout);
	set_fs(oldfs);
	return retval;
}
int lseek(int fd, long offset, int whence)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_lseek(fd, offset, whence);
	set_fs(oldfs);
	return retval;
}
int fstat(int fd, struct stat *buf)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_fstat(fd, buf);
	set_fs(oldfs);
	return retval;
}
int read(int fd, void *buffer, size_t count)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_read(fd, buffer, count) ;
	set_fs(oldfs);
	return retval;
}
int write(int fd, const void *buffer, size_t count)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_write(fd, buffer, count);
	set_fs(oldfs);
	return retval;
}
int writev(int fd, const struct iovec  *vector, int count)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_writev(fd, vector, count);
	set_fs(oldfs);
	return retval;
}
int unlink(const char *pathname)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_unlink(pathname);
	set_fs(oldfs);
	return retval;
}
int open(const char *filename, int flags, int mode)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_open(filename, flags, mode);
	set_fs(oldfs);
	return retval;
}
int close(int fd)
{
	int retval;
	mm_segment_t oldfs;
	oldfs = get_fs(); set_fs(KERNEL_DS);
	retval = sys_close(fd);
	set_fs(oldfs);
	return retval;
}
