#ifndef __KORBIT_ARPA_INET_H__
#define __KORBIT_ARPA_INET_H__

#include <linux/inet.h>
#include <linux/in.h>

static inline char* inet_ntoa(struct in_addr in)
{
   return in_ntoa(in.s_addr);
}

static inline int inet_aton(const char *cp, struct in_addr *inp)
{
	unsigned long l;
	unsigned int val;
	int i;

        if (!cp || !inp)
                return 0;

	l = 0;
	for (i = 0; i < 4; i++) 
	{
		l <<= 8;
		if (*cp != '\0') 
		{
			val = 0;
			while (*cp != '\0' && *cp != '.') 
			{
                                if (*cp < '0' || '9' < *cp)
                                        return 0;
                                
				val *= 10;
				val += *cp - '0';
				cp++;
			}
                        if (val > 255)
                                return 0;
                        
			l |= val;
			if (*cp != '\0') 
				cp++;
		}
	}
	inp->s_addr = htonl(l);

        return 1;
}

#endif /* __KORBIT_ARPA_INET_H__ */
