#ifndef __KORBIT_FCNTL_H__
#define __KORBIT_FCNTL_H__

#include <linux/mm.h>
#include <linux/file.h>
#include <linux/smp_lock.h>

#include <asm/fcntl.h>

#include <stdio.h>

#define SETFL_MASK (O_APPEND | O_NONBLOCK | O_NDELAY | FASYNC)

static inline int fcntl(int fd, int cmd, long arg)
{
        struct file *filp = fd2file(fd);
        long err = -EINVAL;
        
        switch (cmd)
        {
        case F_SETFD:
        case F_GETFD:
                err = 0;
                break;
        case F_GETFL:
                if (filp)
                        err = filp->f_flags;
                break;
        case F_SETFL:
                if (filp)
                {
                        lock_kernel();

                        /* required for strict SunOS emulation */
                        if (O_NONBLOCK != O_NDELAY)
                          if (arg & O_NDELAY)
                            arg |= O_NONBLOCK;

                        filp->f_flags = (arg & SETFL_MASK) | 
                                        (filp->f_flags & ~SETFL_MASK);
                        err = 0;
                        unlock_kernel();
                }
                break;
        }
        return err;
}

#endif
