#ifndef __KORBIT_STDIO_H__
#define __KORBIT_STDIO_H__

#include <asm/segment.h>
#include <asm/uaccess.h>
#include <linux/smp_lock.h>
#include <linux/kernel.h>
#include <linux/fs.h>
#include <linux/sched.h>
#include <linux/uio.h>
#include <linux/dcache.h>
#include <linux/file.h>
#include <linux/highuid.h>
#include <sys/socket.h>
#include <sys/poll.h>

#include <errno.h>
#define  fgets(x,y,z) 
#define fputs(device,msg)
#define printf(format,args...) printk(format,##args)
#define fprintf(device,format,args...) printk(format,##args)
#define fflush(x)

#define SEEK_SET       0       /* Seek from beginning of file.  */
#define SEEK_CUR       1       /* Seek from current position.  */
#define SEEK_END       2       /* Seek from end of file.  */


extern int sys_setsockopt(int fd, int level, int optname,
		                        void *optval, int optlen);
extern int sys_getsockopt(int fd, int level, int optname,
		                        void *__restrict optval, int *__restrict optlen);
extern __kernel_sighandler_t sys_signal (int sig, __kernel_sighandler_t __handler);
extern int sys_socket(int domain, int type, int protocol);
extern int sys_sigaction (int sig, const struct sigaction * act,struct sigaction *oact);
extern int sys_getitimer (int which,struct itimerval *value);
extern int sys_setitimer (int which,const struct itimerval *new,struct itimerval *old);
extern int sys_gettimeofday (struct timeval *tv,void *tz);
extern int sys_bind(int sockfd, struct sockaddr *my_addr, int addrlen);
extern int sys_connect(int sockfd, struct sockaddr *serv_addr, int addrlen);
extern int sys_listen(int sockfd, int backlog);
extern int sys_accept(int sockfd, struct sockaddr *addr, int *addrlen);
extern int sys_shutdown(int sockfd, int how);
extern int sys_fcntl (int fd, int cmd, ...);
extern int sys_getsockname (int fd, struct sockaddr *addr, int *len);
extern int sys_poll (struct pollfd *fds, int nfds, int timeout);

extern int sys_lseek(int fd, long offset, int whence);
extern int sys_fstat(int fd, struct stat *buf);
extern int sys_read(int fd, void *buffer, size_t count) ;
extern int sys_write(int fd, const void *buffer, size_t count);
extern int sys_writev(int fd, const struct iovec  *vector, int count);
extern int sys_unlink(const char *pathname);





#endif
