#ifndef __WRAPPER__
#define __WRAPPER__
#include <stdio.h>
extern int setsockopt(int fd, int level, int optname,
		                                        void *optval, int optlen);
extern int getsockopt(int fd, int level, int optname,
		                                        void *__restrict optval, int *__restrict optlen);
extern __kernel_sighandler_t signal (int sig, __kernel_sighandler_t __handler);
extern int socket(int domain, int type, int protocol);
extern int sigaction (int sig, const struct sigaction * act,struct sigaction *oact);
extern int getitimer (int which,struct itimerval *value);
extern int setitimer (int which,const struct itimerval *new,struct itimerval *old);
extern int gettimeofday (struct timeval *tv,void *tz);
extern int bind(int sockfd, struct sockaddr *my_addr, int addrlen);
extern int connect(int sockfd, struct sockaddr *serv_addr, int addrlen);
extern int listen(int sockfd, int backlog);
extern int accept(int sockfd, struct sockaddr *addr, int *addrlen);
extern int shutdown(int sockfd, int how);
extern int fcntl (int fd, int cmd, ...);
extern int getsockname (int fd, struct sockaddr *addr, int *len);
extern int poll (struct pollfd *fds, int nfds, int timeout);

extern int lseek(int fd, long offset, int whence);
extern int fstat(int fd, struct stat *buf);
extern int read(int fd, void *buffer, size_t count) ;
extern int write(int fd, const void *buffer, size_t count);
extern int writev(int fd, const struct iovec  *vector, int count);
extern int unlink(const char *pathname);
extern int open(const char *filename, int flags, int mode);
extern int close(int fd);
#endif

