#include <linux/config.h>
#include <linux/version.h>
#include <linux/module.h>
#if defined(MODVERSIONS)
#include <linux/modversions.h>
#endif

#include <linux/kernel.h>
#include <linux/fs.h>
#include <linux/string.h>
#include <linux/module.h>
#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/smp_lock.h>

#include <asm/signal.h>
extern int errno;
#include <asm/unistd.h>
#include <asm/semaphore.h>

#include "glib.h"
#include "echo.h"
#include "echo-share.h"

static kthread_t kthread;
int start_server (int argc, char *argv[],kthread_t *pthread);
	
static int echo_thread(kthread_t *pthread);

int init_module(void)
{
  
 klib_start_kthread(echo_thread, &kthread, NULL); 
 printk("<1>ok i initilized\n");
 return 0;
}

/* remove the module */
void cleanup_module(void)
{
    printk("<1>begin quit!!!!\n");
    klib_stop_kthread(&kthread);
}

int echo_thread(kthread_t *pthread)
{

     printk("<1>KLIB_KTHREAD : starting thread \n");

     klib_init_kthread(&kthread, "echo thread");
     
     start_server(0,NULL,pthread);
     
     printk("<1>KLIB_THREAD : exiting thread loop\n");


     return 0;
}

void closeme(int s)
{
	CORBA_Environment ev;

	printk("<1>Oh, I Quit!\n");
	CORBA_exception_init(&ev);
	
	echo_srv_finish_object(&ev);
	echo_srv_finish_poa(&ev);
	CORBA_exception_free(&ev);

	klib_exit_kthread(&kthread);
}

int
start_server (int argc, char *argv[],kthread_t *pthread)
{
    CORBA_Environment ev;
    CORBA_ORB orb;
    Echo echo_client = CORBA_OBJECT_NIL;
    char *retval;
    
    sys_signal(SIGKILL, (__kernel_sighandler_t)closeme);
    
    CORBA_exception_init(&ev);
    printk("<1>begin init...\n");
    orb = CORBA_ORB_init(&argc, argv, "orbit-local-orb", &ev);
    if(ev._major != CORBA_NO_EXCEPTION)
    {
	    printk("<1>error orb init\n");
    }
    else
    {
	    printk("<1> orb init success\n");
    }
    

    echo_srv_start_poa(orb, &ev);
    g_assert(ev._major == CORBA_NO_EXCEPTION);
    echo_client = echo_srv_start_object(&ev);
    retval = CORBA_ORB_object_to_string(orb, echo_client, &ev);
    g_assert(ev._major == CORBA_NO_EXCEPTION);
    printk("<1>%s\n" ,retval); 
    CORBA_free(retval);

    CORBA_ORB_run (orb, &ev);

    echo_srv_finish_object(&ev);
    echo_srv_finish_poa(&ev);
    CORBA_exception_free(&ev);

    return 0;
}

